# Templates

## Get templates by organization

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /organizations/{organization}/templates`

### Parameters

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |

### Example responses

> 200 Response

```json
[
	{
		"active_user_count": 0,
		"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
		"activity_bump_ms": 0,
		"allow_user_autostart": true,
		"allow_user_autostop": true,
		"allow_user_cancel_workspace_jobs": true,
		"autostart_requirement": {
			"days_of_week": ["monday"]
		},
		"autostop_requirement": {
			"days_of_week": ["monday"],
			"weeks": 0
		},
		"build_time_stats": {
			"property1": {
				"p50": 123,
				"p95": 146
			},
			"property2": {
				"p50": 123,
				"p95": 146
			}
		},
		"created_at": "2019-08-24T14:15:22Z",
		"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
		"created_by_name": "string",
		"default_ttl_ms": 0,
		"deprecated": true,
		"deprecation_message": "string",
		"description": "string",
		"display_name": "string",
		"failure_ttl_ms": 0,
		"icon": "string",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"max_port_share_level": "owner",
		"name": "string",
		"organization_display_name": "string",
		"organization_icon": "string",
		"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
		"organization_name": "string",
		"provisioner": "terraform",
		"require_active_version": true,
		"time_til_dormant_autodelete_ms": 0,
		"time_til_dormant_ms": 0,
		"updated_at": "2019-08-24T14:15:22Z"
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                               |
| ------ | ------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------------ |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

<h3 id="get-templates-by-organization-responseschema">Response Schema</h3>

Status Code **200**

| Name                                                                                  | Type                                                                                                                | Required | Restrictions | Description                                                                                                                                                                                                                                                                                                    |
| ------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------- | -------- | ------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `[array item]`                                                                        | array                                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» active_user_count`                                                                 | integer                                                                                                             | false    |              | Active user count is set to -1 when loading.                                                                                                                                                                                                                                                                   |
| `» active_version_id`                                                                 | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» activity_bump_ms`                                                                  | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_autostart`                                                              | boolean                                                                                                             | false    |              | Allow user autostart and AllowUserAutostop are enterprise-only. Their values are only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                        |
| `» allow_user_autostop`                                                               | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_cancel_workspace_jobs`                                                  | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» autostart_requirement`                                                             | [codersdk.TemplateAutostartRequirement](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateautostartrequirement) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» days_of_week`                                                                     | array                                                                                                               | false    |              | Days of week is a list of days of the week in which autostart is allowed to happen. If no days are specified, autostart is not allowed.                                                                                                                                                                        |
| `» autostop_requirement`                                                              | [codersdk.TemplateAutostopRequirement](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateautostoprequirement)   | false    |              | Autostop requirement and AutostartRequirement are enterprise features. Its value is only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                     |
| `»» days_of_week`                                                                     | array                                                                                                               | false    |              | Days of week is a list of days of the week on which restarts are required. Restarts happen within the user's quiet hours (in their configured timezone). If no days are specified, restarts are not required. Weekdays cannot be specified twice.                                                              |
| Restarts will only happen on weekdays in this list on weeks which line up with Weeks. |                                                                                                                     |          |              |                                                                                                                                                                                                                                                                                                                |
| `»» weeks`                                                                            | integer                                                                                                             | false    |              | Weeks is the number of weeks between required restarts. Weeks are synced across all workspaces (and Coder deployments) using modulo math on a hardcoded epoch week of January 2nd, 2023 (the first Monday of 2023). Values of 0 or 1 indicate weekly restarts. Values of 2 indicate fortnightly restarts, etc. |
| `» build_time_stats`                                                                  | [codersdk.TemplateBuildTimeStats](/docs/@v2.17.3/reference/api/schemas/#codersdktemplatebuildtimestats)             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» [any property]`                                                                   | [codersdk.TransitionStats](/docs/@v2.17.3/reference/api/schemas/#codersdktransitionstats)                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p50`                                                                             | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p95`                                                                             | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_at`                                                                        | string(date-time)                                                                                                   | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_id`                                                                     | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_name`                                                                   | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» default_ttl_ms`                                                                    | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecated`                                                                        | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecation_message`                                                               | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» description`                                                                       | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» display_name`                                                                      | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» failure_ttl_ms`                                                                    | integer                                                                                                             | false    |              | Failure ttl ms TimeTilDormantMillis, and TimeTilDormantAutoDeleteMillis are enterprise-only. Their values are used if your license is entitled to use the advanced template scheduling feature.                                                                                                                |
| `» icon`                                                                              | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» id`                                                                                | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» max_port_share_level`                                                              | [codersdk.WorkspaceAgentPortShareLevel](/docs/@v2.17.3/reference/api/schemas/#codersdkworkspaceagentportsharelevel) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» name`                                                                              | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_display_name`                                                         | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_icon`                                                                 | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_id`                                                                   | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_name`                                                                 | string(url)                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» provisioner`                                                                       | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» require_active_version`                                                            | boolean                                                                                                             | false    |              | Require active version mandates that workspaces are built with the active template version.                                                                                                                                                                                                                    |
| `» time_til_dormant_autodelete_ms`                                                    | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» time_til_dormant_ms`                                                               | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» updated_at`                                                                        | string(date-time)                                                                                                   | false    |              |                                                                                                                                                                                                                                                                                                                |

#### Enumerated Values

| Property               | Value           |
| ---------------------- | --------------- |
| `max_port_share_level` | `owner`         |
| `max_port_share_level` | `authenticated` |
| `max_port_share_level` | `public`        |
| `provisioner`          | `terraform`     |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Create template by organization

### Code samples

```shell
# Example request using curl
curl -X POST http://coder-server:8080/api/v2/organizations/{organization}/templates \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`POST /organizations/{organization}/templates`

> Body parameter

```json
{
	"activity_bump_ms": 0,
	"allow_user_autostart": true,
	"allow_user_autostop": true,
	"allow_user_cancel_workspace_jobs": true,
	"autostart_requirement": {
		"days_of_week": ["monday"]
	},
	"autostop_requirement": {
		"days_of_week": ["monday"],
		"weeks": 0
	},
	"default_ttl_ms": 0,
	"delete_ttl_ms": 0,
	"description": "string",
	"disable_everyone_group_access": true,
	"display_name": "string",
	"dormant_ttl_ms": 0,
	"failure_ttl_ms": 0,
	"icon": "string",
	"max_port_share_level": "owner",
	"name": "string",
	"require_active_version": true,
	"template_version_id": "0ba39c92-1f1b-4c32-aa3e-9925d7713eb1"
}
```

### Parameters

| Name           | In   | Type                                                                                                  | Required | Description     |
| -------------- | ---- | ----------------------------------------------------------------------------------------------------- | -------- | --------------- |
| `organization` | path | string                                                                                                | true     | Organization ID |
| `body`         | body | [codersdk.CreateTemplateRequest](/docs/@v2.17.3/reference/api/schemas/#codersdkcreatetemplaterequest) | true     | Request body    |

### Example responses

> 200 Response

```json
{
	"active_user_count": 0,
	"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
	"activity_bump_ms": 0,
	"allow_user_autostart": true,
	"allow_user_autostop": true,
	"allow_user_cancel_workspace_jobs": true,
	"autostart_requirement": {
		"days_of_week": ["monday"]
	},
	"autostop_requirement": {
		"days_of_week": ["monday"],
		"weeks": 0
	},
	"build_time_stats": {
		"property1": {
			"p50": 123,
			"p95": 146
		},
		"property2": {
			"p50": 123,
			"p95": 146
		}
	},
	"created_at": "2019-08-24T14:15:22Z",
	"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
	"created_by_name": "string",
	"default_ttl_ms": 0,
	"deprecated": true,
	"deprecation_message": "string",
	"description": "string",
	"display_name": "string",
	"failure_ttl_ms": 0,
	"icon": "string",
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"max_port_share_level": "owner",
	"name": "string",
	"organization_display_name": "string",
	"organization_icon": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"organization_name": "string",
	"provisioner": "terraform",
	"require_active_version": true,
	"time_til_dormant_autodelete_ms": 0,
	"time_til_dormant_ms": 0,
	"updated_at": "2019-08-24T14:15:22Z"
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template examples by organization

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/examples \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /organizations/{organization}/templates/examples`

### Parameters

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |

### Example responses

> 200 Response

```json
[
	{
		"description": "string",
		"icon": "string",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"markdown": "string",
		"name": "string",
		"tags": ["string"],
		"url": "string"
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                             |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateExample](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateexample) |

<h3 id="get-template-examples-by-organization-responseschema">Response Schema</h3>

Status Code **200**

| Name            | Type         | Required | Restrictions | Description |
| --------------- | ------------ | -------- | ------------ | ----------- |
| `[array item]`  | array        | false    |              |             |
| `» description` | string       | false    |              |             |
| `» icon`        | string       | false    |              |             |
| `» id`          | string(uuid) | false    |              |             |
| `» markdown`    | string       | false    |              |             |
| `» name`        | string       | false    |              |             |
| `» tags`        | array        | false    |              |             |
| `» url`         | string       | false    |              |             |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get templates by organization and template name

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /organizations/{organization}/templates/{templatename}`

### Parameters

| Name           | In   | Type         | Required | Description     |
| -------------- | ---- | ------------ | -------- | --------------- |
| `organization` | path | string(uuid) | true     | Organization ID |
| `templatename` | path | string       | true     | Template name   |

### Example responses

> 200 Response

```json
{
	"active_user_count": 0,
	"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
	"activity_bump_ms": 0,
	"allow_user_autostart": true,
	"allow_user_autostop": true,
	"allow_user_cancel_workspace_jobs": true,
	"autostart_requirement": {
		"days_of_week": ["monday"]
	},
	"autostop_requirement": {
		"days_of_week": ["monday"],
		"weeks": 0
	},
	"build_time_stats": {
		"property1": {
			"p50": 123,
			"p95": 146
		},
		"property2": {
			"p50": 123,
			"p95": 146
		}
	},
	"created_at": "2019-08-24T14:15:22Z",
	"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
	"created_by_name": "string",
	"default_ttl_ms": 0,
	"deprecated": true,
	"deprecation_message": "string",
	"description": "string",
	"display_name": "string",
	"failure_ttl_ms": 0,
	"icon": "string",
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"max_port_share_level": "owner",
	"name": "string",
	"organization_display_name": "string",
	"organization_icon": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"organization_name": "string",
	"provisioner": "terraform",
	"require_active_version": true,
	"time_til_dormant_autodelete_ms": 0,
	"time_til_dormant_ms": 0,
	"updated_at": "2019-08-24T14:15:22Z"
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template version by organization, template, and name

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /organizations/{organization}/templates/{templatename}/versions/{templateversionname}`

### Parameters

| Name                  | In   | Type         | Required | Description           |
| --------------------- | ---- | ------------ | -------- | --------------------- |
| `organization`        | path | string(uuid) | true     | Organization ID       |
| `templatename`        | path | string       | true     | Template name         |
| `templateversionname` | path | string       | true     | Template version name |

### Example responses

> 200 Response

```json
{
	"archived": true,
	"created_at": "2019-08-24T14:15:22Z",
	"created_by": {
		"avatar_url": "http://example.com",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"username": "string"
	},
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"job": {
		"canceled_at": "2019-08-24T14:15:22Z",
		"completed_at": "2019-08-24T14:15:22Z",
		"created_at": "2019-08-24T14:15:22Z",
		"error": "string",
		"error_code": "REQUIRED_TEMPLATE_VARIABLES",
		"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"queue_position": 0,
		"queue_size": 0,
		"started_at": "2019-08-24T14:15:22Z",
		"status": "pending",
		"tags": {
			"property1": "string",
			"property2": "string"
		},
		"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
	},
	"message": "string",
	"name": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"readme": "string",
	"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
	"updated_at": "2019-08-24T14:15:22Z",
	"warnings": ["UNSUPPORTED_WORKSPACES"]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                    |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get previous template version by organization, template, and name

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/organizations/{organization}/templates/{templatename}/versions/{templateversionname}/previous \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /organizations/{organization}/templates/{templatename}/versions/{templateversionname}/previous`

### Parameters

| Name                  | In   | Type         | Required | Description           |
| --------------------- | ---- | ------------ | -------- | --------------------- |
| `organization`        | path | string(uuid) | true     | Organization ID       |
| `templatename`        | path | string       | true     | Template name         |
| `templateversionname` | path | string       | true     | Template version name |

### Example responses

> 200 Response

```json
{
	"archived": true,
	"created_at": "2019-08-24T14:15:22Z",
	"created_by": {
		"avatar_url": "http://example.com",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"username": "string"
	},
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"job": {
		"canceled_at": "2019-08-24T14:15:22Z",
		"completed_at": "2019-08-24T14:15:22Z",
		"created_at": "2019-08-24T14:15:22Z",
		"error": "string",
		"error_code": "REQUIRED_TEMPLATE_VARIABLES",
		"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"queue_position": 0,
		"queue_size": 0,
		"started_at": "2019-08-24T14:15:22Z",
		"status": "pending",
		"tags": {
			"property1": "string",
			"property2": "string"
		},
		"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
	},
	"message": "string",
	"name": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"readme": "string",
	"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
	"updated_at": "2019-08-24T14:15:22Z",
	"warnings": ["UNSUPPORTED_WORKSPACES"]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                    |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Create template version by organization

### Code samples

```shell
# Example request using curl
curl -X POST http://coder-server:8080/api/v2/organizations/{organization}/templateversions \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`POST /organizations/{organization}/templateversions`

> Body parameter

```json
{
	"example_id": "string",
	"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
	"message": "string",
	"name": "string",
	"provisioner": "terraform",
	"storage_method": "file",
	"tags": {
		"property1": "string",
		"property2": "string"
	},
	"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
	"user_variable_values": [
		{
			"name": "string",
			"value": "string"
		}
	]
}
```

### Parameters

| Name           | In   | Type                                                                                                                | Required | Description                     |
| -------------- | ---- | ------------------------------------------------------------------------------------------------------------------- | -------- | ------------------------------- |
| `organization` | path | string(uuid)                                                                                                        | true     | Organization ID                 |
| `body`         | body | [codersdk.CreateTemplateVersionRequest](/docs/@v2.17.3/reference/api/schemas/#codersdkcreatetemplateversionrequest) | true     | Create template version request |

### Example responses

> 201 Response

```json
{
	"archived": true,
	"created_at": "2019-08-24T14:15:22Z",
	"created_by": {
		"avatar_url": "http://example.com",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"username": "string"
	},
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"job": {
		"canceled_at": "2019-08-24T14:15:22Z",
		"completed_at": "2019-08-24T14:15:22Z",
		"created_at": "2019-08-24T14:15:22Z",
		"error": "string",
		"error_code": "REQUIRED_TEMPLATE_VARIABLES",
		"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"queue_position": 0,
		"queue_size": 0,
		"started_at": "2019-08-24T14:15:22Z",
		"status": "pending",
		"tags": {
			"property1": "string",
			"property2": "string"
		},
		"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
	},
	"message": "string",
	"name": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"readme": "string",
	"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
	"updated_at": "2019-08-24T14:15:22Z",
	"warnings": ["UNSUPPORTED_WORKSPACES"]
}
```

### Responses

| Status | Meaning                                                      | Description | Schema                                                                                    |
| ------ | ------------------------------------------------------------ | ----------- | ----------------------------------------------------------------------------------------- |
| 201    | [Created](https://tools.ietf.org/html/rfc7231#section-6.3.2) | Created     | [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get all templates

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates`

### Example responses

> 200 Response

```json
[
	{
		"active_user_count": 0,
		"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
		"activity_bump_ms": 0,
		"allow_user_autostart": true,
		"allow_user_autostop": true,
		"allow_user_cancel_workspace_jobs": true,
		"autostart_requirement": {
			"days_of_week": ["monday"]
		},
		"autostop_requirement": {
			"days_of_week": ["monday"],
			"weeks": 0
		},
		"build_time_stats": {
			"property1": {
				"p50": 123,
				"p95": 146
			},
			"property2": {
				"p50": 123,
				"p95": 146
			}
		},
		"created_at": "2019-08-24T14:15:22Z",
		"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
		"created_by_name": "string",
		"default_ttl_ms": 0,
		"deprecated": true,
		"deprecation_message": "string",
		"description": "string",
		"display_name": "string",
		"failure_ttl_ms": 0,
		"icon": "string",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"max_port_share_level": "owner",
		"name": "string",
		"organization_display_name": "string",
		"organization_icon": "string",
		"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
		"organization_name": "string",
		"provisioner": "terraform",
		"require_active_version": true,
		"time_til_dormant_autodelete_ms": 0,
		"time_til_dormant_ms": 0,
		"updated_at": "2019-08-24T14:15:22Z"
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                               |
| ------ | ------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------------ |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

<h3 id="get-all-templates-responseschema">Response Schema</h3>

Status Code **200**

| Name                                                                                  | Type                                                                                                                | Required | Restrictions | Description                                                                                                                                                                                                                                                                                                    |
| ------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------- | -------- | ------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `[array item]`                                                                        | array                                                                                                               | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» active_user_count`                                                                 | integer                                                                                                             | false    |              | Active user count is set to -1 when loading.                                                                                                                                                                                                                                                                   |
| `» active_version_id`                                                                 | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» activity_bump_ms`                                                                  | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_autostart`                                                              | boolean                                                                                                             | false    |              | Allow user autostart and AllowUserAutostop are enterprise-only. Their values are only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                        |
| `» allow_user_autostop`                                                               | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» allow_user_cancel_workspace_jobs`                                                  | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» autostart_requirement`                                                             | [codersdk.TemplateAutostartRequirement](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateautostartrequirement) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» days_of_week`                                                                     | array                                                                                                               | false    |              | Days of week is a list of days of the week in which autostart is allowed to happen. If no days are specified, autostart is not allowed.                                                                                                                                                                        |
| `» autostop_requirement`                                                              | [codersdk.TemplateAutostopRequirement](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateautostoprequirement)   | false    |              | Autostop requirement and AutostartRequirement are enterprise features. Its value is only used if your license is entitled to use the advanced template scheduling feature.                                                                                                                                     |
| `»» days_of_week`                                                                     | array                                                                                                               | false    |              | Days of week is a list of days of the week on which restarts are required. Restarts happen within the user's quiet hours (in their configured timezone). If no days are specified, restarts are not required. Weekdays cannot be specified twice.                                                              |
| Restarts will only happen on weekdays in this list on weeks which line up with Weeks. |                                                                                                                     |          |              |                                                                                                                                                                                                                                                                                                                |
| `»» weeks`                                                                            | integer                                                                                                             | false    |              | Weeks is the number of weeks between required restarts. Weeks are synced across all workspaces (and Coder deployments) using modulo math on a hardcoded epoch week of January 2nd, 2023 (the first Monday of 2023). Values of 0 or 1 indicate weekly restarts. Values of 2 indicate fortnightly restarts, etc. |
| `» build_time_stats`                                                                  | [codersdk.TemplateBuildTimeStats](/docs/@v2.17.3/reference/api/schemas/#codersdktemplatebuildtimestats)             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»» [any property]`                                                                   | [codersdk.TransitionStats](/docs/@v2.17.3/reference/api/schemas/#codersdktransitionstats)                           | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p50`                                                                             | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `»»» p95`                                                                             | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_at`                                                                        | string(date-time)                                                                                                   | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_id`                                                                     | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» created_by_name`                                                                   | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» default_ttl_ms`                                                                    | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecated`                                                                        | boolean                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» deprecation_message`                                                               | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» description`                                                                       | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» display_name`                                                                      | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» failure_ttl_ms`                                                                    | integer                                                                                                             | false    |              | Failure ttl ms TimeTilDormantMillis, and TimeTilDormantAutoDeleteMillis are enterprise-only. Their values are used if your license is entitled to use the advanced template scheduling feature.                                                                                                                |
| `» icon`                                                                              | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» id`                                                                                | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» max_port_share_level`                                                              | [codersdk.WorkspaceAgentPortShareLevel](/docs/@v2.17.3/reference/api/schemas/#codersdkworkspaceagentportsharelevel) | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» name`                                                                              | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_display_name`                                                         | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_icon`                                                                 | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_id`                                                                   | string(uuid)                                                                                                        | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» organization_name`                                                                 | string(url)                                                                                                         | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» provisioner`                                                                       | string                                                                                                              | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» require_active_version`                                                            | boolean                                                                                                             | false    |              | Require active version mandates that workspaces are built with the active template version.                                                                                                                                                                                                                    |
| `» time_til_dormant_autodelete_ms`                                                    | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» time_til_dormant_ms`                                                               | integer                                                                                                             | false    |              |                                                                                                                                                                                                                                                                                                                |
| `» updated_at`                                                                        | string(date-time)                                                                                                   | false    |              |                                                                                                                                                                                                                                                                                                                |

#### Enumerated Values

| Property               | Value           |
| ---------------------- | --------------- |
| `max_port_share_level` | `owner`         |
| `max_port_share_level` | `authenticated` |
| `max_port_share_level` | `public`        |
| `provisioner`          | `terraform`     |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template examples

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/examples \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates/examples`

### Example responses

> 200 Response

```json
[
	{
		"description": "string",
		"icon": "string",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"markdown": "string",
		"name": "string",
		"tags": ["string"],
		"url": "string"
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                             |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateExample](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateexample) |

<h3 id="get-template-examples-responseschema">Response Schema</h3>

Status Code **200**

| Name            | Type         | Required | Restrictions | Description |
| --------------- | ------------ | -------- | ------------ | ----------- |
| `[array item]`  | array        | false    |              |             |
| `» description` | string       | false    |              |             |
| `» icon`        | string       | false    |              |             |
| `» id`          | string(uuid) | false    |              |             |
| `» markdown`    | string       | false    |              |             |
| `» name`        | string       | false    |              |             |
| `» tags`        | array        | false    |              |             |
| `» url`         | string       | false    |              |             |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template metadata by ID

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates/{template}`

### Parameters

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses

> 200 Response

```json
{
	"active_user_count": 0,
	"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
	"activity_bump_ms": 0,
	"allow_user_autostart": true,
	"allow_user_autostop": true,
	"allow_user_cancel_workspace_jobs": true,
	"autostart_requirement": {
		"days_of_week": ["monday"]
	},
	"autostop_requirement": {
		"days_of_week": ["monday"],
		"weeks": 0
	},
	"build_time_stats": {
		"property1": {
			"p50": 123,
			"p95": 146
		},
		"property2": {
			"p50": 123,
			"p95": 146
		}
	},
	"created_at": "2019-08-24T14:15:22Z",
	"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
	"created_by_name": "string",
	"default_ttl_ms": 0,
	"deprecated": true,
	"deprecation_message": "string",
	"description": "string",
	"display_name": "string",
	"failure_ttl_ms": 0,
	"icon": "string",
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"max_port_share_level": "owner",
	"name": "string",
	"organization_display_name": "string",
	"organization_icon": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"organization_name": "string",
	"provisioner": "terraform",
	"require_active_version": true,
	"time_til_dormant_autodelete_ms": 0,
	"time_til_dormant_ms": 0,
	"updated_at": "2019-08-24T14:15:22Z"
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Delete template by ID

### Code samples

```shell
# Example request using curl
curl -X DELETE http://coder-server:8080/api/v2/templates/{template} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`DELETE /templates/{template}`

### Parameters

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses

> 200 Response

```json
{
	"detail": "string",
	"message": "string",
	"validations": [
		{
			"detail": "string",
			"field": "string"
		}
	]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Response](/docs/@v2.17.3/reference/api/schemas/#codersdkresponse) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Update template metadata by ID

### Code samples

```shell
# Example request using curl
curl -X PATCH http://coder-server:8080/api/v2/templates/{template} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`PATCH /templates/{template}`

### Parameters

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses

> 200 Response

```json
{
	"active_user_count": 0,
	"active_version_id": "eae64611-bd53-4a80-bb77-df1e432c0fbc",
	"activity_bump_ms": 0,
	"allow_user_autostart": true,
	"allow_user_autostop": true,
	"allow_user_cancel_workspace_jobs": true,
	"autostart_requirement": {
		"days_of_week": ["monday"]
	},
	"autostop_requirement": {
		"days_of_week": ["monday"],
		"weeks": 0
	},
	"build_time_stats": {
		"property1": {
			"p50": 123,
			"p95": 146
		},
		"property2": {
			"p50": 123,
			"p95": 146
		}
	},
	"created_at": "2019-08-24T14:15:22Z",
	"created_by_id": "9377d689-01fb-4abf-8450-3368d2c1924f",
	"created_by_name": "string",
	"default_ttl_ms": 0,
	"deprecated": true,
	"deprecation_message": "string",
	"description": "string",
	"display_name": "string",
	"failure_ttl_ms": 0,
	"icon": "string",
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"max_port_share_level": "owner",
	"name": "string",
	"organization_display_name": "string",
	"organization_icon": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"organization_name": "string",
	"provisioner": "terraform",
	"require_active_version": true,
	"time_til_dormant_autodelete_ms": 0,
	"time_til_dormant_ms": 0,
	"updated_at": "2019-08-24T14:15:22Z"
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Template](/docs/@v2.17.3/reference/api/schemas/#codersdktemplate) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template DAUs by ID

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template}/daus \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates/{template}/daus`

### Parameters

| Name       | In   | Type         | Required | Description |
| ---------- | ---- | ------------ | -------- | ----------- |
| `template` | path | string(uuid) | true     | Template ID |

### Example responses

> 200 Response

```json
{
	"entries": [
		{
			"amount": 0,
			"date": "string"
		}
	],
	"tz_hour_offset": 0
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                              |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.DAUsResponse](/docs/@v2.17.3/reference/api/schemas/#codersdkdausresponse) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## List template versions by template ID

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template}/versions \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates/{template}/versions`

### Parameters

| Name               | In    | Type         | Required | Description                           |
| ------------------ | ----- | ------------ | -------- | ------------------------------------- |
| `template`         | path  | string(uuid) | true     | Template ID                           |
| `after_id`         | query | string(uuid) | false    | After ID                              |
| `include_archived` | query | boolean      | false    | Include archived versions in the list |
| `limit`            | query | integer      | false    | Page limit                            |
| `offset`           | query | integer      | false    | Page offset                           |

### Example responses

> 200 Response

```json
[
	{
		"archived": true,
		"created_at": "2019-08-24T14:15:22Z",
		"created_by": {
			"avatar_url": "http://example.com",
			"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
			"username": "string"
		},
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"job": {
			"canceled_at": "2019-08-24T14:15:22Z",
			"completed_at": "2019-08-24T14:15:22Z",
			"created_at": "2019-08-24T14:15:22Z",
			"error": "string",
			"error_code": "REQUIRED_TEMPLATE_VARIABLES",
			"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
			"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
			"queue_position": 0,
			"queue_size": 0,
			"started_at": "2019-08-24T14:15:22Z",
			"status": "pending",
			"tags": {
				"property1": "string",
				"property2": "string"
			},
			"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
		},
		"message": "string",
		"name": "string",
		"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
		"readme": "string",
		"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
		"updated_at": "2019-08-24T14:15:22Z",
		"warnings": ["UNSUPPORTED_WORKSPACES"]
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                             |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

<h3 id="list-template-versions-by-template-id-responseschema">Response Schema</h3>

Status Code **200**

| Name                 | Type                                                                                                | Required | Restrictions | Description |
| -------------------- | --------------------------------------------------------------------------------------------------- | -------- | ------------ | ----------- |
| `[array item]`       | array                                                                                               | false    |              |             |
| `» archived`         | boolean                                                                                             | false    |              |             |
| `» created_at`       | string(date-time)                                                                                   | false    |              |             |
| `» created_by`       | [codersdk.MinimalUser](/docs/@v2.17.3/reference/api/schemas/#codersdkminimaluser)                   | false    |              |             |
| `»» avatar_url`      | string(uri)                                                                                         | false    |              |             |
| `»» id`              | string(uuid)                                                                                        | true     |              |             |
| `»» username`        | string                                                                                              | true     |              |             |
| `» id`               | string(uuid)                                                                                        | false    |              |             |
| `» job`              | [codersdk.ProvisionerJob](/docs/@v2.17.3/reference/api/schemas/#codersdkprovisionerjob)             | false    |              |             |
| `»» canceled_at`     | string(date-time)                                                                                   | false    |              |             |
| `»» completed_at`    | string(date-time)                                                                                   | false    |              |             |
| `»» created_at`      | string(date-time)                                                                                   | false    |              |             |
| `»» error`           | string                                                                                              | false    |              |             |
| `»» error_code`      | [codersdk.JobErrorCode](/docs/@v2.17.3/reference/api/schemas/#codersdkjoberrorcode)                 | false    |              |             |
| `»» file_id`         | string(uuid)                                                                                        | false    |              |             |
| `»» id`              | string(uuid)                                                                                        | false    |              |             |
| `»» queue_position`  | integer                                                                                             | false    |              |             |
| `»» queue_size`      | integer                                                                                             | false    |              |             |
| `»» started_at`      | string(date-time)                                                                                   | false    |              |             |
| `»» status`          | [codersdk.ProvisionerJobStatus](/docs/@v2.17.3/reference/api/schemas/#codersdkprovisionerjobstatus) | false    |              |             |
| `»» tags`            | object                                                                                              | false    |              |             |
| `»»» [any property]` | string                                                                                              | false    |              |             |
| `»» worker_id`       | string(uuid)                                                                                        | false    |              |             |
| `» message`          | string                                                                                              | false    |              |             |
| `» name`             | string                                                                                              | false    |              |             |
| `» organization_id`  | string(uuid)                                                                                        | false    |              |             |
| `» readme`           | string                                                                                              | false    |              |             |
| `» template_id`      | string(uuid)                                                                                        | false    |              |             |
| `» updated_at`       | string(date-time)                                                                                   | false    |              |             |
| `» warnings`         | array                                                                                               | false    |              |             |

#### Enumerated Values

| Property     | Value                         |
| ------------ | ----------------------------- |
| `error_code` | `REQUIRED_TEMPLATE_VARIABLES` |
| `status`     | `pending`                     |
| `status`     | `running`                     |
| `status`     | `succeeded`                   |
| `status`     | `canceling`                   |
| `status`     | `canceled`                    |
| `status`     | `failed`                      |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Update active template version by template ID

### Code samples

```shell
# Example request using curl
curl -X PATCH http://coder-server:8080/api/v2/templates/{template}/versions \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`PATCH /templates/{template}/versions`

> Body parameter

```json
{
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
}
```

### Parameters

| Name       | In   | Type                                                                                                              | Required | Description               |
| ---------- | ---- | ----------------------------------------------------------------------------------------------------------------- | -------- | ------------------------- |
| `template` | path | string(uuid)                                                                                                      | true     | Template ID               |
| `body`     | body | [codersdk.UpdateActiveTemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdkupdateactivetemplateversion) | true     | Modified template version |

### Example responses

> 200 Response

```json
{
	"detail": "string",
	"message": "string",
	"validations": [
		{
			"detail": "string",
			"field": "string"
		}
	]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Response](/docs/@v2.17.3/reference/api/schemas/#codersdkresponse) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Archive template unused versions by template id

### Code samples

```shell
# Example request using curl
curl -X POST http://coder-server:8080/api/v2/templates/{template}/versions/archive \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`POST /templates/{template}/versions/archive`

> Body parameter

```json
{
	"all": true
}
```

### Parameters

| Name       | In   | Type                                                                                                                    | Required | Description     |
| ---------- | ---- | ----------------------------------------------------------------------------------------------------------------------- | -------- | --------------- |
| `template` | path | string(uuid)                                                                                                            | true     | Template ID     |
| `body`     | body | [codersdk.ArchiveTemplateVersionsRequest](/docs/@v2.17.3/reference/api/schemas/#codersdkarchivetemplateversionsrequest) | true     | Archive request |

### Example responses

> 200 Response

```json
{
	"detail": "string",
	"message": "string",
	"validations": [
		{
			"detail": "string",
			"field": "string"
		}
	]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                      |
| ------ | ------------------------------------------------------- | ----------- | --------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.Response](/docs/@v2.17.3/reference/api/schemas/#codersdkresponse) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template version by template ID and name

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templates/{template}/versions/{templateversionname} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templates/{template}/versions/{templateversionname}`

### Parameters

| Name                  | In   | Type         | Required | Description           |
| --------------------- | ---- | ------------ | -------- | --------------------- |
| `template`            | path | string(uuid) | true     | Template ID           |
| `templateversionname` | path | string       | true     | Template version name |

### Example responses

> 200 Response

```json
[
	{
		"archived": true,
		"created_at": "2019-08-24T14:15:22Z",
		"created_by": {
			"avatar_url": "http://example.com",
			"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
			"username": "string"
		},
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"job": {
			"canceled_at": "2019-08-24T14:15:22Z",
			"completed_at": "2019-08-24T14:15:22Z",
			"created_at": "2019-08-24T14:15:22Z",
			"error": "string",
			"error_code": "REQUIRED_TEMPLATE_VARIABLES",
			"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
			"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
			"queue_position": 0,
			"queue_size": 0,
			"started_at": "2019-08-24T14:15:22Z",
			"status": "pending",
			"tags": {
				"property1": "string",
				"property2": "string"
			},
			"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
		},
		"message": "string",
		"name": "string",
		"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
		"readme": "string",
		"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
		"updated_at": "2019-08-24T14:15:22Z",
		"warnings": ["UNSUPPORTED_WORKSPACES"]
	}
]
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                             |
| ------ | ------------------------------------------------------- | ----------- | -------------------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | array of [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

<h3 id="get-template-version-by-template-id-and-name-responseschema">Response Schema</h3>

Status Code **200**

| Name                 | Type                                                                                                | Required | Restrictions | Description |
| -------------------- | --------------------------------------------------------------------------------------------------- | -------- | ------------ | ----------- |
| `[array item]`       | array                                                                                               | false    |              |             |
| `» archived`         | boolean                                                                                             | false    |              |             |
| `» created_at`       | string(date-time)                                                                                   | false    |              |             |
| `» created_by`       | [codersdk.MinimalUser](/docs/@v2.17.3/reference/api/schemas/#codersdkminimaluser)                   | false    |              |             |
| `»» avatar_url`      | string(uri)                                                                                         | false    |              |             |
| `»» id`              | string(uuid)                                                                                        | true     |              |             |
| `»» username`        | string                                                                                              | true     |              |             |
| `» id`               | string(uuid)                                                                                        | false    |              |             |
| `» job`              | [codersdk.ProvisionerJob](/docs/@v2.17.3/reference/api/schemas/#codersdkprovisionerjob)             | false    |              |             |
| `»» canceled_at`     | string(date-time)                                                                                   | false    |              |             |
| `»» completed_at`    | string(date-time)                                                                                   | false    |              |             |
| `»» created_at`      | string(date-time)                                                                                   | false    |              |             |
| `»» error`           | string                                                                                              | false    |              |             |
| `»» error_code`      | [codersdk.JobErrorCode](/docs/@v2.17.3/reference/api/schemas/#codersdkjoberrorcode)                 | false    |              |             |
| `»» file_id`         | string(uuid)                                                                                        | false    |              |             |
| `»» id`              | string(uuid)                                                                                        | false    |              |             |
| `»» queue_position`  | integer                                                                                             | false    |              |             |
| `»» queue_size`      | integer                                                                                             | false    |              |             |
| `»» started_at`      | string(date-time)                                                                                   | false    |              |             |
| `»» status`          | [codersdk.ProvisionerJobStatus](/docs/@v2.17.3/reference/api/schemas/#codersdkprovisionerjobstatus) | false    |              |             |
| `»» tags`            | object                                                                                              | false    |              |             |
| `»»» [any property]` | string                                                                                              | false    |              |             |
| `»» worker_id`       | string(uuid)                                                                                        | false    |              |             |
| `» message`          | string                                                                                              | false    |              |             |
| `» name`             | string                                                                                              | false    |              |             |
| `» organization_id`  | string(uuid)                                                                                        | false    |              |             |
| `» readme`           | string                                                                                              | false    |              |             |
| `» template_id`      | string(uuid)                                                                                        | false    |              |             |
| `» updated_at`       | string(date-time)                                                                                   | false    |              |             |
| `» warnings`         | array                                                                                               | false    |              |             |

#### Enumerated Values

| Property     | Value                         |
| ------------ | ----------------------------- |
| `error_code` | `REQUIRED_TEMPLATE_VARIABLES` |
| `status`     | `pending`                     |
| `status`     | `running`                     |
| `status`     | `succeeded`                   |
| `status`     | `canceling`                   |
| `status`     | `canceled`                    |
| `status`     | `failed`                      |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Get template version by ID

### Code samples

```shell
# Example request using curl
curl -X GET http://coder-server:8080/api/v2/templateversions/{templateversion} \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`GET /templateversions/{templateversion}`

### Parameters

| Name              | In   | Type         | Required | Description         |
| ----------------- | ---- | ------------ | -------- | ------------------- |
| `templateversion` | path | string(uuid) | true     | Template version ID |

### Example responses

> 200 Response

```json
{
	"archived": true,
	"created_at": "2019-08-24T14:15:22Z",
	"created_by": {
		"avatar_url": "http://example.com",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"username": "string"
	},
	"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
	"job": {
		"canceled_at": "2019-08-24T14:15:22Z",
		"completed_at": "2019-08-24T14:15:22Z",
		"created_at": "2019-08-24T14:15:22Z",
		"error": "string",
		"error_code": "REQUIRED_TEMPLATE_VARIABLES",
		"file_id": "8a0cfb4f-ddc9-436d-91bb-75133c583767",
		"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
		"queue_position": 0,
		"queue_size": 0,
		"started_at": "2019-08-24T14:15:22Z",
		"status": "pending",
		"tags": {
			"property1": "string",
			"property2": "string"
		},
		"worker_id": "ae5fa6f7-c55b-40c1-b40a-b36ac467652b"
	},
	"message": "string",
	"name": "string",
	"organization_id": "7c60d51f-b44e-4682-87d6-449835ea4de6",
	"readme": "string",
	"template_id": "c6d67e98-83ea-49f0-8812-e4abae2b68bc",
	"updated_at": "2019-08-24T14:15:22Z",
	"warnings": ["UNSUPPORTED_WORKSPACES"]
}
```

### Responses

| Status | Meaning                                                 | Description | Schema                                                                                    |
| ------ | ------------------------------------------------------- | ----------- | ----------------------------------------------------------------------------------------- |
| 200    | [OK](https://tools.ietf.org/html/rfc7231#section-6.3.1) | OK          | [codersdk.TemplateVersion](/docs/@v2.17.3/reference/api/schemas/#codersdktemplateversion) |

To perform this operation, you must be authenticated. [Learn more](/docs/@v2.17.3/reference/api/authentication/).

## Patch template version by ID

### Code samples

```shell
# Example request using curl
curl -X PATCH http://coder-server:8080/api/v2/templateversions/{templateversion} \
  -H 'Content-Type: application/json' \
  -H 'Accept: application/json' \
  -H 'Coder-Session-Token: API_KEY'
```

`PATCH /templateversions/{templateversion}`

> Body parameter

```json
{
	"message": "string",
	"name": "string"
}
```

### Parameters

| Name              | In   | Type                                                                                                              | Required | Description                    |
| ----------------- | ---- | ----------------------------------------------------------------------------------------------------------------- | -------- | ------------------------------ |
| `templateversion` | path | string(uuid)                                                                                                      | true     | Template version ID            |
[...]
